// WindowsPrimer class
#pragma comment( lib, "ddraw.lib")
#ifndef DDPRIMER_H
#define DDPRIMER_H

#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>

#define TIMER_ID        1
#define TIMER_RATE      100

class WindowsPrimer
{
protected :
	HWND		hWnd;
	MSG			msg;
	WNDCLASS	wc;

public :
	WindowsPrimer();
	WindowsPrimer(
		HINSTANCE hMainInst,
		char *szWinName,
		WNDPROC wndproc
		);
	BOOL windowReveal(
		//char *szName,
		char *szTitle,
		int nWinMode,
		HINSTANCE hMainInst,
		int width,
		int height);
	WPARAM	reaction();
	HWND getHandle();
};

// Q[[vgݍނ߂ɃbZ[W[v֐(WindowsPrimer class
//  reaction() I[o[Ch
class GameWindow : public WindowsPrimer
{
private:
	HDC						hdc;
public :	
	LPDIRECTDRAW            lpDD;           // DirectDraw object
	LPDIRECTDRAWSURFACE     lpDDSPrimary;   // DirectDraw primary surface
	LPDIRECTDRAWSURFACE     lpDDSBack;      // DirectDraw back surface
	LPDIRECTDRAWCLIPPER		lpClip;
	int screen_width;
	int screen_height;
	GameWindow(
		HINSTANCE hMainInst,
		char *szWinName,
		WNDPROC wndproc
		);
	BOOL windowReveal(
		//char *szName,
		char *szTitle,
		int nWinMode,
		HINSTANCE hMainInst,
		int width,
		int height);
	void finiObjects( void );
	BOOL initDirectDraw();
	void render();
	bool activateHDC();
	bool clearScreen();
	void disactivateHDC();
	bool drawLine( COLORREF color, int x1, int y1, int x2, int y2);
	bool textOut( int x, int y, char *str);
};

// CEEChE̍\z
int WINAPI WinMain(
					HINSTANCE hThisInst,
					HINSTANCE hPrevInst,
					LPSTR lpstrArgs,
					int nWinMode
					);

#endif DDPRIMER_H
