//	ddprimerlib.cpp
#pragma comment( lib, "d3drm.lib")
#pragma comment( lib, "winmm.lib")
#pragma comment( lib, "ddraw.lib")

#include <windows.h>
#include <math.h>	//	for demo
#include "ddprimer.h"

#define INITGUID
#define	RED		RGB(255,0,0)
#define GREEN	RGB(0,255,0)
#define BLUE	RGB(0,0,255)
#define WIND_WIDTH	640
#define WIND_HEIGHT 480

//////////////////////////////////////////////////
//	Declaration of functions
//////////////////////////////////////////////////
void gameLoop( HWND hWnd);
int WINAPI WinMain(	HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lpstrArgs, int nWinMode);
LRESULT CALLBACK WindowProcedure( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
//////////////////////////////////////////////////
//	Declaration of global valuables
//////////////////////////////////////////////////
BOOL		bActive; // flag that indicates if this application active.
GameWindow*	pGW;	 // pointer to GameWindow

double pi = 3.1415927;	//	for demo
int x = 50;			//	for demo
int y = 0;			//	for demo

int WINAPI WinMain(	HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lpstrArgs, int nWinMode)
{
	pGW = &GameWindow( hThisInst, "ddskelton", WindowProcedure);

	if( pGW->windowReveal( "ddskelton demo", nWinMode, hThisInst, WIND_WIDTH, WIND_HEIGHT) != TRUE)
		return 0;

	pGW->reaction();	// run the main roop
	return 0;
}

LRESULT CALLBACK WindowProcedure( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch( msg )
    {
	case WM_CREATE:
		pGW->clearScreen();
		break;

    case WM_ACTIVATEAPP:
		bActive = wParam;
		break;
	//if you don't want mouse cursor, activate this part
    //case WM_SETCURSOR:
	//	SetCursor(NULL);
	//	return TRUE;
    case WM_TIMER:
		// Flip surfaces
		if( bActive ) {
			gameLoop( hWnd);
			pGW->render();
		}
		break;
	case WM_DESTROY:
		pGW->finiObjects();
		PostQuitMessage(0);
		return FALSE;
	default :
		break;
	}
	return DefWindowProc( hWnd, msg, wParam, lParam);
}

//
// game loop
//
void gameLoop( HWND hWnd)
{
	if( pGW->activateHDC())
	{
		if( !pGW->clearScreen())
		{
			pGW->disactivateHDC();
			return;
		}
		pGW->drawLine( RED,
			WIND_WIDTH/2 + (int)(80*cos(x*pi/180)), WIND_HEIGHT/2 + (int)(80*sin(x*pi/180)),
			WIND_WIDTH/2 + (int)(80*cos(x*pi/180)), WIND_HEIGHT/2 + (int)(80*sin(x*pi/180)));
		pGW->disactivateHDC();
		x+=2;
		if( x > 360)	x = 0;
	}
}

